Global screenx = 640 ;screen size X
Global screeny = 480 ;screen size y

Graphics screenx,screeny,0,2 ;working out graphics from the screen size
SetBuffer BackBuffer() ;setting buffer to back buffer

Global mapsx = 22 ;map x (how far the grid below goes right)
Global mapsy = 21 ;map y (same as aboth but how far it goes down)

Dim array(mapsy,mapsx) ;getting array of below data 0 is tile 1, 1 is tile 2, 2 is tile 3 and so on

Data 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,2,2,2,2,2,2,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,2,2,2,2,2,2,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,2,2,2,2,2,2,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
Data 0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0

Global tile1 = LoadImage("tile1.bmp") ;tile images
Global tile2 = LoadImage("tile2.bmp")
Global tile3 = LoadImage("tile3.bmp")

Global tilew = 50 ;tile width
Global tilel = 50 ;tile length
Global xoffset = 50 ;tile offsets set both these to the same as your width and length unless you want the tiles to overlap
Global yoffset = 50

Global char = LoadImage("char.bmp") ;character image
Global charwidth = 50 ;width and length of character....
Global charhight = 50
Global charx = (screenx/2)-(charwidth/2) ;drawing the character dead center of screen by takeing away half the width and hight from half the screen x + y
Global chary = (screeny/2)-(charhight/2)

Global charl = 0 ;character direction values
Global charr = 0
Global charu = 0
Global chard = 0

Global readinfo = 1 ;read info value for the select part later on

While Not KeyHit(1) ;functions
	Cls
	Fdrawtiles()
	Fmovemap()
	Fdrawchar()
	Fmovechar()
	Flip
Wend

End

Function Fdrawtiles() ;drawing tiles
	
	For y = 1 To mapsy
		For x = 1 To mapsx
			If readinfo = 1 Then Read array(x,y)
			If array(x,y) = 0 Then
				DrawImage(tile1,(x*tilew-xoffset),(y*tilel)-yoffset)
			ElseIf array(x,y) = 1 Then
				DrawImage(tile2,(x*tilew-xoffset),(y*tilel)-yoffset)
				ElseIf array(x,y) = 2 Then
					DrawImage(tile3,(x*tilew-xoffset),(y*tilel)-yoffset)
					EndIf
				Next
			Next
			
			readinfo = 0
	
End Function

Function Fdrawchar() ;drawing character
	
	DrawImage(char,charx,chary)
	
End Function

Function Fmovemap() ;moveing map with character (classic rpg style)
	
	If KeyDown(200) And chard = 0 Then
		If yoffset > tilel Then
			yoffset = yoffset - 1
		Else
			charu = 1
		EndIf
	ElseIf KeyDown(208) And charu = 0 Then
		If yoffset < ((tilel*mapsy)-screeny+tilel) Then
			yoffset = yoffset + 1
		Else
			chard = 1
		EndIf
	ElseIf KeyDown(203) And charr = 0 Then
		If xoffset > tile2 Then
			xoffset = xoffset - 1
		Else
			charl = 1
		EndIf
	ElseIf KeyDown(205) And charl = 0 Then
			If xoffset < ((tilew*mapsx)-screenx+tilew) Then
				xoffset = xoffset + 1
			Else
				charr = 1
			EndIf
		EndIf
		
End Function

Function Fmovechar() ;moveing character
	
	If KeyDown(200) And charu > 0 Then
		If charu = 1 chard = 2
			If chary > 0 Then
				chary = chary - 1
				Select charu
					Case 1
						If chary > (screeny/2)-(charhight/2) Then
							charu = 0
							chard = 0
						EndIf
					Case 2
						If chary < (screeny/2)-(charhight/2) Then
							charu = 0
							chard = 0
						EndIf
				End Select
			Else
				chard = 2
				charu = 3
			EndIf
	ElseIf KeyDown(208) And chard > 0 Then
		If chard = 1 charu = 2
			If chary < (screeny-charhight) Then
				chary = chary - 1
				Select chard
					Case 1
						If chary > (screeny/2)-(charhight/2) Then
							chard = 0
							charu = 0
						EndIf
					Case 2
						If chary < (screeny/2)-(charhight/2) Then
							chard = 0
							charu = 0
						EndIf
				End Select
			Else
				charu = 2
				chard = 3
			EndIf
	ElseIf KeyDown(203) And charl > 0 Then
		If charl = 1 charr = 2
			If charx > 0 Then
				charx = charx - 1
				Select charl
					Case 1
						If charx > (screenx/2)-(charwidth/2) Then
							charr = 0
							charl = 0
						EndIf
					Case 2
						If chary < (screenx/2)-(charwidth/2) Then
							charl = 0
							charr = 0
						EndIf
				End Select
			Else
				charr = 2
				charl = 3
			EndIf
	ElseIf KeyDown(205) And charr > 0 Then
		If charr = 1 charl = 2
			If charx < (screenx-charwidth) Then
				charx = charx - 1
				Select charr
					Case 1
						If chary > (screenx/2)-(charwidth/2) Then
							charl = 0
							charr = 0
						EndIf
					Case 2
						If chary < (screenx/2)-(charwidth/2) Then
							charl = 0
							charr = 0
						EndIf
				End Select
			Else
				charl = 2
				charr = 3
			EndIf
		EndIf
		
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D